#include <Arduino.h>
#include <AccelStepper.h>


const int stepperPinDefinitions[][3] = {{D0,D1,D2}, {D3,D4,D5}}; //Enable, Step, Dir

AccelStepper stepper[sizeof(stepperPinDefinitions)];

int microsteps = 8;

void setup() {
    for(int i = 0; i<sizeof(stepperPinDefinitions);i++){
        stepper[i] = AccelStepper(AccelStepper::FULL2WIRE, stepperPinDefinitions[i][1], stepperPinDefinitions[i][2]);
        pinMode(stepperPinDefinitions[i][0], OUTPUT);
        digitalWrite(stepperPinDefinitions[i][0], LOW);
        stepper[i].setMaxSpeed(5000);
        stepper[i].setAcceleration(5000);
    }


    Serial.begin(9600);


}


void loop() {
    if(Serial.available()>0){
        char c = (char)Serial.read();
        switch(c){
            case 'q':
                stepper[0].moveTo(stepper[0].targetPosition()+50*microsteps);
                break;
            case 'a':
                stepper[0].moveTo(stepper[0].targetPosition()-50*microsteps);
                break;
            case 'w':
                stepper[0].moveTo(stepper[0].targetPosition()+200*microsteps);
                break;
            case 's':
                stepper[0].moveTo(stepper[0].targetPosition()-200*microsteps);
                break;
            case 'e':
                stepper[0].moveTo(stepper[0].targetPosition()+1200*microsteps);
                break;
            case 'd':
                stepper[0].moveTo(stepper[0].targetPosition()-1200*microsteps);
                break;

            case 'r':
                stepper[1].moveTo(stepper[1].targetPosition()+50*microsteps);
                break;
            case 'f':
                stepper[1].moveTo(stepper[1].targetPosition()-50*microsteps);
                break;
            case 't':
                stepper[1].moveTo(stepper[1].targetPosition()+200*microsteps);
                break;
            case 'g':
                stepper[1].moveTo(stepper[1].targetPosition()-200*microsteps);
                break;
            case 'z':
                stepper[1].moveTo(stepper[1].targetPosition()+1200*microsteps);
                break;
            case 'h':
                stepper[1].moveTo(stepper[1].targetPosition()-1200*microsteps);
                break;

            case 'y':
                stepper[0].setCurrentPosition(0);
                break;
            case 'x':
                stepper[1].setCurrentPosition(0);
                break;

            case '1':
                digitalWrite(stepperPinDefinitions[0][0], LOW);
                break;
            case '2':
                digitalWrite(stepperPinDefinitions[0][0], HIGH);
                break;
            case '3':
                digitalWrite(stepperPinDefinitions[1][0], LOW);
                break;
            case '4':
                digitalWrite(stepperPinDefinitions[1][0], HIGH);
                break;
        }
        Serial.print(stepper[0].targetPosition());
        Serial.print(" - ");
        Serial.println(stepper[1].targetPosition());
    }
    for(int i = 0; i<sizeof(stepperPinDefinitions);i++){
        stepper[i].run();
    }
}
